﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Drawing;
using System.Windows.Forms;

namespace CSharpSamples_Khoshamoz.OOP
{
    class GameCharacter1
    {

        public GameCharacter1()
        {
            _bmp = Properties.Resources.character_01;
            _bmp.MakeTransparent();
            _CurrentLocation = new System.Drawing.Point(10, 10);
            _Speed = 2;
        }

        private PictureBox _PictureBoxPaint;
        public PictureBox PictureBoxPaint { get { return _PictureBoxPaint; } set { _PictureBoxPaint = value; } }

        private Point _CurrentLocation;
        public Point CurrentLocation { 
            get 
            { return _CurrentLocation; } 
            set 
            { 
                _CurrentLocation = value;
            } 
        }

        private int _Speed;
        public int Speed { get { return _Speed; } set { _Speed = value; } }

        private Bitmap _bmp;
        public Bitmap bmp { get { return _bmp; } set { _bmp = value; } }

        public void GoLeft()
        {
            _CurrentLocation.X -= _Speed;
            if (_CurrentLocation.X + _bmp.Width < _PictureBoxPaint.Left)
            {
                _CurrentLocation.X = _PictureBoxPaint.Right ;
            }
             _PictureBoxPaint.Refresh();        
        }

        public void GoRight()
        {
            _CurrentLocation.X += _Speed;
            if (_CurrentLocation.X > _PictureBoxPaint.Right)
            {
                _CurrentLocation.X = 0 - _bmp.Width;
            }
            _PictureBoxPaint.Refresh();
        }

        public void GoUp()
        {
            if (_CurrentLocation.Y > _PictureBoxPaint.Top)
            {
                _CurrentLocation.Y -= _Speed;
            }
            _PictureBoxPaint.Refresh();
        }

        public void GoDown()
        {
            if (_CurrentLocation.Y + _bmp.Height < _PictureBoxPaint.Bottom)
            {
                _CurrentLocation.Y += _Speed;
            }
             _PictureBoxPaint.Refresh();
        }


    }
}
